



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ3252: 攻略 可并堆</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ3252: 攻略 可并堆</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 08:02:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>网上有很多人说用dfs序+线段树做...其实stl的堆可以...可并堆可以...很多奇奇怪怪的东西都能做...</p>
<p>可并堆比较好想...也比较好写...</p>
<p>分析：</p>
<p>首先，这是一个网络流做不了的题...数据太大...</p>
<p>其次...我们可以这样考虑一下，这个点的子树中，将这个点的权值仅更新给最大的那个就能满足</p>
<p>之后，在每一个叶子节点上，建立一个大根堆，dfs一遍，将子节点的堆合并，之后找到根节点，将根节点的权值加上当前位置的价值</p>
<p>最后，根节点中前k大的权值和即为答案...</p>
<p>附上代码，精简可行</p>
<div>
<pre class="prettyprint linenums">#include &lt;cstdio&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;cstring&gt;<br />
using namespace std;<br />
#define N 200005<br />
#define ll long long<br />
struct node<br />
{<br />
	int ls,rs,dis;<br />
	ll x;<br />
}mp[N&lt;&lt;1];<br />
struct no<br />
{<br />
	int to,next;<br />
}e[N&lt;&lt;1];<br />
int head[N],cnt,fa[N],a[N],n,K;<br />
void add(int x,int y)<br />
{<br />
	e[cnt].to=y;<br />
	e[cnt].next=head[x];<br />
	head[x]=cnt++;<br />
	return ;<br />
}<br />
int merge(int x,int y)<br />
{<br />
	if(!x)return y;<br />
	if(!y)return x;<br />
	if(mp[x].x&lt;mp[y].x)swap(x,y);<br />
	mp[x].rs=merge(mp[x].rs,y);<br />
	if(mp[mp[x].rs].dis&gt;mp[mp[x].ls].dis)swap(mp[x].ls,mp[x].rs);<br />
	mp[x].dis=mp[mp[x].rs].dis+1;<br />
	return x;<br />
}<br />
void dfs(int x,int from)<br />
{<br />
	for(int i=head[x];i!=-1;i=e[i].next)<br />
	{<br />
		int to1=e[i].to;<br />
		if(to1!=from)<br />
		{<br />
			dfs(to1,x);<br />
			fa[x]=merge(fa[to1],fa[x]);<br />
		}<br />
	}<br />
	mp[fa[x]].x+=a[x];<br />
}<br />
int in1[N];<br />
int main()<br />
{<br />
	memset(head,-1,sizeof(head));<br />
	scanf("%d%d",&amp;n,&amp;K);<br />
	for(int i=1;i&lt;=n;i++)<br />
	{<br />
		scanf("%d",&amp;a[i]);<br />
	}<br />
	for(int i=1;i&lt;n;i++)<br />
	{<br />
		int x,y;<br />
		scanf("%d%d",&amp;x,&amp;y);<br />
		in1[x]++,in1[y]++;<br />
		add(x,y);<br />
		add(y,x);<br />
	}<br />
	int rot=1,num=0;<br />
	for(int i=1;i&lt;=n;i++)<br />
	{<br />
		if(in1[1]==1&amp;&amp;in1[i]!=1)<br />
		{<br />
			rot=i;<br />
		}else<br />
		{<br />
			num++;<br />
			fa[i]=i;<br />
		}<br />
	}<br />
	K=min(num,K);<br />
	dfs(rot,0);<br />
	ll ans=0;<br />
	while(K--)<br />
	{<br />
		ans+=mp[fa[rot]].x;<br />
		mp[fa[rot]].x=0;<br />
		fa[rot]=merge(mp[fa[rot]].ls,mp[fa[rot]].rs);<br />
	}<br />
	printf("%lld\n",ans);<br />
	return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/p49g67q7.html">Python 爬虫模拟登陆知乎</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k5rlr8.html">SQL 存储过程 解析XML</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdxdoz8.html">pom&period;xml 样例</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71x0gq.html">Python中的socket 模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wo74q.html">《K&amp;amp&semi;R》中引用的几个排序算法（shellsort、）以及一个自己乱写的排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/390g76o8.html">&lbrack;ACM&lowbar;数学&rsqb; Counting Solutions to an Integral Equation   （x&plus;2y&plus;2z&equals;n 组合种类）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyrvg9.html">mysqlnd cannot connect to MySQL 4&period;1&plus; using the old insecure authentication解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02r4eq.html">php相关学习资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdlwnr8.html">linux 内存管理大图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dykjq.html">弹出框weeboxs 基本属性总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1kvpq.html">抓取数据同步备份hive</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnrze8.html">在hadoop 的任务中设置 map数量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrk5e8.html">关于现在IT行业从业者一些建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ddevq.html">文件和IO流</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwwgv48.html">Go语言结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ol27e8.html">spring boot 2&period;0&period;3&plus;spring cloud （Finchley）3、声明式调用Feign</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv237r19.html">《C&num;从现象到本质》读书笔记（九）第11章C&num;的数据结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1e061q.html">diskcache</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjew6xq.html">【洛谷P1991】无线通讯网</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kovv6rq.html">前台框架vue&period;js中怎样嵌入 Echarts 组件？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7zy00k9.html">Ubuntu18&period;04教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdovy79.html">使用HttpClient进行https连接（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxl2n8.html">python3 数据科学基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpg60j9.html">mac os x 10&period;9&period;3 升级到10&period;10&period;4 记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjz6m38.html">FatMouse&amp;&num;39&semi; Trade -HZNU寒假集训</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmp5r8.html">GNSS相关网站汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me76zpq.html">python importlib动态导入模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjze138.html">java使用Myeclipse创建Hibernate项目碰到的诸多问题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgz559.html">error LNK2038&colon; 检测到&OpenCurlyDoubleQuote;RuntimeLibrary&rdquo;的不匹配项&colon;  值&OpenCurlyDoubleQuote;MTd&lowbar;StaticDebug&rdquo;不匹配值&OpenCurlyDoubleQuote;MDd&lowbar;DynamicDebug</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgrl7e8.html">ns3构建2 core fat tree出错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
